package icu.fur93.esp32_car.utils

class Utils {
    companion object {
        /**
         * 将 Float 转换为字节数组
         */
        fun floatToBytes(value: Float): ByteArray {
            return value.toBits().let { bits ->
                byteArrayOf(
                    (bits and 0xFF).toByte(),
                    ((bits shr 8) and 0xFF).toByte(),
                    ((bits shr 16) and 0xFF).toByte(),
                    ((bits shr 24) and 0xFF).toByte()
                )
            }
        }

        /**
         * 将字节数组转换为 Float
         */
        fun bytesToFloat(bytes: ByteArray): Float {
            require(bytes.size >= 4) { "字节数组长度必须大于等于4" }

            return Float.fromBits(
                (bytes[3].toInt() and 0xFF shl 24) or
                        (bytes[2].toInt() and 0xFF shl 16) or
                        (bytes[1].toInt() and 0xFF shl 8) or
                        (bytes[0].toInt() and 0xFF)
            )
        }
    }
}